]> git.pld-linux.org Git - packages/rpm.git/blame - rpm.macros
- unbreak macros being "one command" in shell
[packages/rpm.git] / rpm.macros
CommitLineData
b52fc1f1 1# $Revision$, $Date$
cc2b296f 2# PLD Linux rpm macros
a8bf9720 3
90c0eaed 4%epoch 0
31b569b6 5%x8664 x86_64 amd64 ia32e
cd33aab7 6
a544555d 7# kernel compiler
6f86c45e 8%kgcc %{__cc}
cabacfeb 9%kgcc_package gcc
a544555d 10
4343a1f7
ER
11%__rm /bin/rm --interactive=never
12
5f9f9bd7 13# Build system path macros.
14#
8af1c6f5
JB
15%__autoconf autoconf %{?debug:-Wall}
16%__automake automake -a -c -f --foreign
429d047e 17%__autopoint autopoint --force
18
aad1c8e4 19%__gettextize { \
4cd84746 20 if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
31b569b6 21 gettextize --copy --force --no-changelog; \
93bce43f 22 else \
31b569b6 23 gettextize --copy --force --no-changelog --intl; \
4cd84746
JB
24 fi; \
25 if [ ! -f po/Makevars ]; then \
31b569b6 26 cp -f po/Makevars{.template,}; \
4cd84746 27 fi; \
4cd84746 28}
429d047e 29
30%__glib_gettextize glib-gettextize --copy --force
31%__gnome_doc_common gnome-doc-common --copy
db1adf13 32%__gnome_doc_prepare gnome-doc-prepare --copy --force
429d047e 33%__gtkdocize gtkdocize --copy
34%__intltoolize intltoolize --copy --force
35%__libtoolize libtoolize --copy --force
5f9f9bd7 36
702e8027 37# Path to top of build area.
135188cb 38%_topdir %{expand:%%global _topdir %(test -d ../SPECS -a -d ../SOURCES && (cd ..; pwd) || echo $HOME/rpm)}%_topdir
702e8027 39
38e780ca
ER
40# The number of cvs changelog entries kept when building package.
41%_buildchangelogtruncate 20
42
bd1cd543 43%dependencytracking %{nil}
31b569b6 44
073ae3ba
ER
45# Relations between package names that cause dependency loops
46# with legacy packages that cannot be fixed. Relations are
47# specified as
48# p>q
49# where package p has a Requires: on something that package q Provides:
50#
51# XXX Note: that there cannot be any whitespace within the string "p>q",
52# and that both p and q are package names (i.e. no version/release).
53%_dependency_whiteout %{nil}
54
9ba56d1b
AM
55%_smp_mflags %([ -z "$RPM_BUILD_NCPUS" ] \\\
56 && RPM_BUILD_NCPUS="`/usr/bin/getconf _NPROCESSORS_ONLN`"; \\\
57 [ "$RPM_BUILD_NCPUS" -gt 1 ] && echo "-j$RPM_BUILD_NCPUS")
cece03f9 58
59#-----------------------------------------------------------------
60#
61# (re)definition of %{rpm*flags} with %filterout_* support
7c9f98ce
ER
62# BuildRequires: awk
63# BuildRequires: rpmbuild(macros) >= 1.315
cece03f9 64#
65# Flags specified in %filterout_* are removed from %rpm*flags, exactly:
a0bf497e 66# %rpmcflags = %optflags - %filterout - %filterout_c - %filterout_ld
67# %rpmcxxflags = %optflags - %filterout - %filterout_cxx - %filterout_ld
68# %rpmldflags = %optldflags - %filterout_ld
cece03f9 69#
70# Regular expressions are supported, but to avoid some character be treated
71# as regular expression it must be escaped twice.
72
73%filter_out \
bf66145e 74 for (i = 1; i in I; i++) { A=0; \
cece03f9 75 for (f in F) { \
76 if (I[i] ~ "^" F[f] "$") A=1; \
77 }; \
78 if (!A) printf(I[i] FS); \
79 }
80
81%rpmcflags %(awk 'BEGIN {
82 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
a0bf497e 83 split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
cece03f9 84 %{filter_out}
85}')
86
87%rpmcxxflags %(awk 'BEGIN {
a0bf497e 88 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
89 split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
cece03f9 90 %{filter_out}
91}')
92
93%rpmldflags %(awk 'BEGIN {
b699ccff 94 split("%{?optldflags}",I);
cece03f9 95 split("%{?filterout_ld}",F)
96 %{filter_out}
97}')
98
111942c6 99# rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
100# but, don't use it, better use gcc as linker
101%ld_rpmldflags %(awk 'BEGIN {
102 split("%{rpmldflags}",F);
103 for (f in F) {
104 s = F[f];
105 if (s ~ /^-Wl,/) {
106 s = substr(s,5);
107 gsub(/,/," ",s);
108 };
109 printf(s FS);
110 };
111}')
112
cd33aab7 113#-----------------------------------------------------------------
9f0287b5 114%configure2_13 { \
cd33aab7
AM
115 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
116 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
117 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
af18d245 118 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
cd33aab7 119 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
d4392e78 120 FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
c55f2219 121 CPPFLAGS="${CPPFLAGS:-}" ; export CPPFLAGS ; \
4eac2e49
AM
122 %{?__cc:CC="%{__cc}" ; export CC ; } \
123 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
5b0f0ac9 124 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
fa74a11c 125 --host=%{_target_platform} \
cd33aab7
AM
126 --prefix=%{_prefix} \
127 --exec-prefix=%{_exec_prefix} \
128 --bindir=%{_bindir} \
129 --sbindir=%{_sbindir} \
130 --sysconfdir=%{_sysconfdir} \
131 --datadir=%{_datadir} \
132 --includedir=%{_includedir} \
133 --libdir=%{_libdir} \
134 --libexecdir=%{_libexecdir} \
135 --localstatedir=%{_localstatedir} \
136 --sharedstatedir=%{_sharedstatedir} \
137 --mandir=%{_mandir} \
138 --infodir=%{_infodir} \
c3420100 139 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
8b4be1e1 140 %{dependencytracking} \
cd33aab7
AM
141}
142
53c34296
ER
143# override __cmake to add -j4 in your ~/.rpmmacros for parallel make
144%__cmake /usr/bin/cmake
29771119
ER
145%cmake { \
146CC="%{__cc}" \
147CXX="%{__cxx}" \
148CFLAGS="%{rpmcflags}" \
149CXXFLAGS="%{rpmcxxflags}" \
53c34296
ER
150%{__cmake} \
151}
152
153# override __scons to add -j4 in your ~/.rpmmacros for parallel make
154%__scons /usr/bin/scons
155%scons { \
156%{__scons} \
13eb0f84
ER
157 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
158 CFLAGS="${CFLAGS:-%rpmcflags}" \
159 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
160 FFLAGS="${FFLAGS:-%rpmcflags}" \
161 CPPFLAGS="${CPPFLAGS:-}" \
162 %{?__cc:CC="%{__cc}"} \
163 %{?__cxx:CXX="%{__cxx}"} \
164 libsuffix=%{_lib} \
165 prefix=%{_prefix} \
29771119
ER
166}
167
ac093701 168# waf. see waf.spec
53c34296 169# override __waf to add -j4 in your ~/.rpmmacros for parallel make
ac093701
ER
170%__waf /usr/bin/waf
171%waf { \
ac093701
ER
172CC="%{__cc}" \
173CXX="%{__cxx}" \
1624498d 174CPP="%{__cpp}" \
ac093701
ER
175CFLAGS="%{rpmcflags}" \
176CXXFLAGS="%{rpmcxxflags}" \
177%{__waf} \
ac093701
ER
178}
179
85f82bec 180#----------------------------------------------------------------
b7626f51 181#%configure_cache 0
43f81f06 182%configure_cache_file %{buildroot}.configure.cache
7e4e3f2b 183
b8cf6778 184%configure {./configure \
85f82bec
AF
185 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
186 CFLAGS="${CFLAGS:-%rpmcflags}" \
af18d245 187 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
85f82bec 188 FFLAGS="${FFLAGS:-%rpmcflags}" \
d4392e78 189 FCFLAGS="${FCFLAGS:-%rpmcflags}" \
418d9760 190 CPPFLAGS="${CPPFLAGS:-}" \
4eac2e49
AM
191 %{?__cc:CC="%{__cc}"} \
192 %{?__cxx:CXX="%{__cxx}"} \
a9bea0f7 193 --host=%{_target_platform} \
85f82bec
AF
194 --build=%{_target_platform} \
195 --prefix=%{_prefix} \
196 --exec-prefix=%{_exec_prefix} \
197 --bindir=%{_bindir} \
198 --sbindir=%{_sbindir} \
199 --sysconfdir=%{_sysconfdir} \
200 --datadir=%{_datadir} \
201 --includedir=%{_includedir} \
202 --libdir=%{_libdir} \
203 --libexecdir=%{_libexecdir} \
204 --localstatedir=%{_localstatedir} \
205 --sharedstatedir=%{_sharedstatedir} \
206 --mandir=%{_mandir} \
207 --infodir=%{_infodir} \
c3420100 208 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
8b4be1e1 209 %{dependencytracking} \
b7626f51 210 %{?configure_cache:--cache-file=%{configure_cache_file}} \
85f82bec
AF
211}
212
9cd5fb46
ER
213# overload to insert debuginfo package
214%prep \
215%if 0%{?_enable_debug_packages}\
216%{debug_package}\
217%endif\
218%%prep\
219%{nil}
220
cd33aab7 221# Location of autoconf macros
742f3bc4 222%_aclocaldir %{expand:%%global _aclocaldir %(aclocal --print-ac-dir || echo ERROR)}%_aclocaldir
cd33aab7 223
32720a50 224# Location of omf files
742f3bc4 225%_omf_dest_dir %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
32720a50 226
c5eece2c 227# Location of pkgconfig files
a46897a7 228%_pkgconfigdir /usr/%{_lib}/pkgconfig
c5eece2c 229
c917274d 230# Location of desktop files
231%_desktopdir /usr/share/applications
510f694c 232%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
c917274d 233
fb08fb4a 234# Location of pixmaps for applnk/desktop files
3a9bb008 235%_pixmapsdir /usr/share/pixmaps
cd33aab7 236
fb08fb4a 237# Location of themable icons for applnk/desktop files
986c3bcd 238%_iconsdir /usr/share/icons
239
c5eece2c
JB
240# Location of fonts directories
241%_fontsdir /usr/share/fonts
242
5cfcbc9e 243# Location of Gtk and associated libraries documentation
43f81f06 244%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
5cfcbc9e 245
eee08b2d 246# Location of KDE documentation
43f81f06 247%_kdedocdir %{_defaultdocdir}/kde/HTML
eee08b2d 248
a7cad6ae 249# unsermake script
250%__unsermake /usr/share/unsermake/unsermake
251
cd33aab7
AM
252# Current date
253%date %(LC_ALL="C" date +"%a %b %d %Y")
254
cd33aab7
AM
255# Example files, programs, scripts...
256%_examplesdir /usr/src/examples
257
7127e0fc 258# Alternative kernel type/version
c604d0a9 259%_alt_kernel %{nil}%{?alt_kernel:-%{?alt_kernel}}
7127e0fc 260
bd63739a 261# The directory holding Linux kernel sources
c604d0a9 262%_kernelsrcdir /usr/src/linux%{_alt_kernel}
bd63739a 263
cd33aab7 264# If non-empty "debug" macro defined, add "dbg" suffix to release number
5b0f0ac9 265%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
cd33aab7 266
5b0f0ac9 267# Requires name = version-release
48c1bf9f 268%requires_releq() %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %{N} = %|E?{%{E}:}|%{V}-%{R}\\n' | grep -v 'is not')
511ee4c6 269
135188cb
ER
270%releq_kernel %{expand:%%global releq_kernel %(R=$(LC_ALL=C rpm -q --qf '%{N} = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel
271%releq_kernel_up %{expand:%%global releq_kernel_up %(R=$(LC_ALL=C rpm -q --qf '%{N}-up = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_up
272%releq_kernel_smp() %{expand:%%global releq_kernel_smp %(R=$(LC_ALL=C rpm -q --qf '%{N}-smp = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_smp
d606f9ca
ER
273%requires_releq_kernel(s:) Requires%{-s:(%{-s*})}: %releq_kernel
274%requires_releq_kernel_up(s:) Requires%{-s:(%{-s*})}: %releq_kernel_up
275%requires_releq_kernel_smp(s:) Requires%{-s:(%{-s*})}: %releq_kernel_smp
511ee4c6 276
48c1bf9f
ER
277# XXX: why epoch 0 is stripped?
278%requires_eq() %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %{N} = %|E?{%{E}:}|%{V}\\n' | sed -e 's/ 0:/ /' | grep -v 'is not')
279%requires_eq_to() %(LC_ALL="C" rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}' %2 | grep -v "is not")
e478b9e7 280
a1551c98 281%apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
8dea1306 282
283# kernel version-release handling
a1551c98
ER
284%__kernel_ver %{expand:%%global __kernel_ver %(VER_H=%{_kernelsrcdir}/include/linux/utsrelease.h; [ -f $VER_H ] || VER_H=%{_kernelsrcdir}/include/linux/version.h; [ -f $VER_H ] && (grep UTS_RELEASE $VER_H 2>/dev/null | head -n 1 | cut -d'"' -f2) || (awk '/^VERSION/ { ver = $0; gsub(/VERSION.*=/, NIL, ver); } /^PATCHLEVEL/ { plev = $0; gsub(/PATCHLEVEL.*=/, NIL, plev); } /^SUBLEVEL/ { slev = $0; gsub(/SUBLEVEL.*=/, NIL, slev); } /^EXTRAVERSION/ { ever = $0; gsub(/EXTRAVERSION.*=/, NIL, ever); gsub(/ /, NIL, ever); } END { printf("%d.%d.%d%s", ver, plev, slev, ever); }' %{_kernelsrcdir}/Makefile 2> /dev/null))}%__kernel_ver
285%__kernel_rel %{expand:%%global __kernel_rel %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rel
286%__kernel_rpmvr %{expand:%%global __kernel_rpmvr %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rpmvr
287%_kernel_ver %{expand:%%global _kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}}%_kernel_ver
288%_kernel_ver_str %{expand:%%global _kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')}%_kernel_ver_str
fd4d8ee0 289
c2c27a5a 290# sgml macros
31b569b6
ER
291%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
292%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
293%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
294%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
295%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
296%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
c2c27a5a 297%docbook_sgmlcat_fix() { for l in \
298'' \
299' -- default decl --' \
300'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
301' -- hacks for opensp --' \
302'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
303'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
304'' \
305; do echo $l; done >> %1 \
306}
307
31bd34a8
ER
308# vim - "
309
f3f40db8
ER
310# minimum file size needed for compressed documents.
311# just smaller files than this get larger when compressed.
cdbfc157
ER
312# some stats:
313# - 0 byte file compressed was 25 bytes .gz
314# - 39 byte file was compressed as 57
315# - with test/test.spec@man 158 byte file was compressed also 158
316%_min_compress_bytes 159
f3f40db8 317
cd33aab7
AM
318#-----------------------------------------------------------------
319# find and gzip all files in %{_mandir} and %{infodir}
320#
321# Requires: xargs, find
322#
323#%no_install_post_compress_docs 1
324%__spec_install_post_compress_docs { \
f67bd19e 325%{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
026ed59b 326 for i in /usr/share/man /usr/X11R6/man; do \
cd33aab7 327 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
026ed59b 328 echo "Compress man pages: $i"; \
f3f40db8
ER
329 find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
330 find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
38e531f0
ER
331 find $RPM_BUILD_ROOT$i -type l | while read a; do \
332 m=$(readlink $a); \
333 rm -f $a; \
334 echo .so ${m##*/} > $a; \
335 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
336 done; \
f3f40db8 337 find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
cd33aab7
AM
338 fi; \
339 done; \
91bfff1c
JB
340 if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
341 echo "Compress info pages: %{_infodir}"; \
342 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
343 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
344 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
026ed59b 345 fi; \
f67bd19e 346}; __spec_install_post_compress_docs } }
cd33aab7
AM
347
348#-----------------------------------------------------------------
349# Strip executable binaries and shared object files
350#
351# Requires: find, awk, strip, cut, xargs
352#
ee170415
JB
353# Special macros which affect this process:
354#%no_install_post_strip 1 # disable stripping at all
355#%_noautostrip regexp # exclude files matching (anchored!) regex from stripping
356#%_autostripall regexp # strip files matching (anchored!) regex using plain strip
357#%_autostripunneeded regexp # strip files matching (anchored!) regex using strip --strip-unneeded
358#%_autostripdebug regexp # strip files matching (anchored!) regex using strip --strip-debug
359#
cd33aab7 360%__spec_install_post_strip {%{!?debug: \
f67bd19e 361%{!?no_install_post_strip:__spec_install_post_strip() { \
65e03cc0 362if [ -d "$RPM_BUILD_ROOT" ]; then \
31bd34a8
ER
363 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
364 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
fefadad0
ER
365 if [ "$modulelist" ]; then \
366 modulecount=$(echo "$modulelist" | wc -l); \
7f1d3873 367 printf "Stripping %d kernel modules..." $modulecount; \
6cf69412
ER
368 echo "$modulelist" | xargs -l512 chmod u+w; \
369 echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
370 echo "DONE"; \
371 fi; \
31bd34a8 372 fi; \
559c4907 373 filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
d65f5d0e
JB
374 if [ -n "$filelist" ]; then \
375 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
376 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
377 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
ee170415 378 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
d65f5d0e 379 if [ -n "$elfexelist" ]; then \
fefadad0 380 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
d65f5d0e
JB
381 chmod u+w $elfexelist; \
382 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
383 echo "DONE"; \
384 fi; \
385 if [ -n "$elfsharedlist" ]; then \
fefadad0 386 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
d65f5d0e
JB
387 chmod u+w $elfsharedlist; \
388 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
389 echo "DONE"; \
390 fi; \
391 if [ -n "$archiveslist" ]; then \
fefadad0 392 printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
d65f5d0e
JB
393 chmod u+w $archiveslist; \
394 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
395 echo "DONE"; \
396 fi; \
65e03cc0 397 fi; \
559c4907
ER
398 filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
399 filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
400 filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
d65f5d0e 401 if [ -n "$filelist_all" ]; then \
fefadad0 402 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
ee170415 403 chmod u+w $filelist_all; \
d65f5d0e 404 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
fc87add2 405 echo "DONE"; \
cd33aab7 406 fi; \
d65f5d0e 407 if [ -n "$filelist_unneeded" ]; then \
fefadad0 408 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
ee170415 409 chmod u+w $filelist_unneeded; \
d65f5d0e 410 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
fc87add2 411 echo "DONE"; \
5b0f0ac9 412 fi; \
d65f5d0e 413 if [ -n "$filelist_debug" ]; then \
fefadad0 414 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
ee170415 415 chmod u+w $filelist_debug; \
d65f5d0e 416 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
fc87add2 417 echo "DONE"; \
f80cefa3 418 fi; \
f67bd19e 419fi; }; __spec_install_post_strip } } }
31b569b6 420
cc545e1a 421#-----------------------------------------------------------------
422# remove all RPATH from executable binaries and shared object files
423#
424# Requires: find, awk, cut, xargs, chrpath, uname
425#
ee170415
JB
426# Special macros which affect this process
427#%no_install_post_chrpath 1 # disable chrpath at all
428#%_noautochrpath regex # exclude files matching (anchored!) regex from chrpath
429#
cc545e1a 430%__spec_install_post_chrpath {%{!?debug: \
f67bd19e 431%{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
f80cefa3 432if [ -d "$RPM_BUILD_ROOT" ]; then \
559c4907 433 files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
65e03cc0 434 if [ -n "$files" ]; then \
0faed11b 435 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
fd3a42b0 436 fi; \
65e03cc0 437 if [ -n "$objs" ]; then \
fefadad0 438 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
65e03cc0
ER
439 echo "$objs" | \
440 while read file; do \
441 rpath= ; \
442 chmod u+w "$file"; \
443 for dir in `chrpath -l "$file" | \
444 awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'` ; do \
445 case $dir in \
446 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
447 echo "remove-rpath: $dir in $file"; \
448 ;; \
449 * ) \
450 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
451 else rpath="$rpath:$dir" ; fi ; \
452 ;; \
453 esac ; \
454 done ; \
455 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
456 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
457 done; \
458 fi; \
f67bd19e 459fi; }; __spec_install_post_chrpath } } }
31b569b6 460
22a54b3e 461#-----------------------------------------------------------------
93b46c00 462# Find and gzip all kernel modules
463#
464# Requires: find
465#
43f81f06 466#%no_install_post_compress_modules 1
93b46c00 467%__spec_install_post_compress_modules { \
f67bd19e 468%{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
9cf7c1b9 469 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
9cf7c1b9 470 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
fefadad0
ER
471 if [ "$q" ]; then \
472 printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
473 echo "$q" | xargs -r %{__gzip} -9nf; \
474 echo "DONE"; \
475 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
476 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
477 fi; \
31b569b6 478 fi; \
f67bd19e 479}; __spec_install_post_compress_modules } }
cd33aab7 480
e4d71427
ER
481# Remove common Perl files we don't package
482%__spec_install_post_perl_clean {\
483%{!?no_install_post_perl_clean: \
484%{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
485} }
486
aad1c8e4 487#-----------------------------------------------------------------
cc6c554c 488# Update GConf2 schemas
aad1c8e4 489#
490# Requires: GConf2
491#
5b8ed3c0 492%gconf_schema_install() \
31b569b6 493 umask 022; \
2b633092
ER
494 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
495%{nil}
5b8ed3c0 496
497%gconf_schema_uninstall() \
429d047e 498if [ $1 = 0 ]; then \
31b569b6
ER
499 umask 022; \
500 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
2b633092 501fi; \
429d047e 502%{nil}
503
504#-----------------------------------------------------------------
505# Update desktop MIME database
96999189 506# requires: desktop-file-utils
429d047e 507#
c6f21aa8 508%update_desktop_database_post() {{\
429d047e 509 umask 022; \
db1adf13 510 /usr/bin/update-desktop-database -q; \
c6f21aa8 511}}%{nil}
429d047e 512
c6f21aa8 513%update_desktop_database_postun() {{\
2b633092 514if [ "$1" = "0" ]; then \
429d047e 515 umask 022; \
db1adf13 516 /usr/bin/update-desktop-database -q; \
2b633092 517fi; \
c6f21aa8 518}}%{nil}
429d047e 519
db1adf13 520#-----------------------------------------------------------------
521# Update shared MIME info database
522# requires: shared-mime-info
523#
c6f21aa8 524%update_mime_database() {{\
db1adf13 525 umask 022; \
526 /usr/bin/update-mime-database %{_datadir}/mime; \
c6f21aa8 527}}%{nil}
db1adf13 528
529#-----------------------------------------------------------------
530# Update icon cache
531# requires: gtk+
532#
c6f21aa8 533%update_icon_cache() {{\
db1adf13 534 umask 022; \
8ffd1cc2 535 /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
c6f21aa8 536}}%{nil}
db1adf13 537
429d047e 538#-----------------------------------------------------------------
539# Update scrollkeeper database
540# requires: scrollkeeper
541#
542%scrollkeeper_update_post() \
429d047e 543 /usr/bin/scrollkeeper-update -q; \
2b633092 544%{nil}
429d047e 545
546%scrollkeeper_update_postun() \
2b633092 547if [ "$1" = "0" ]; then \
429d047e 548 /usr/bin/scrollkeeper-update -q; \
2b633092 549fi; \
429d047e 550%{nil}
551
cd33aab7
AM
552#-----------------------------------------------------------------
553# post %install sequence:
554# - autodeps exceptions
555# - compress all man and info pages,
556# - strip all ELF executables and ELF shared objects if not %debug.
5b0f0ac9 557# - compress kernel modules if any
cd33aab7
AM
558
559###################################################################
560# Requires/Provides automation
561# exceptions system by Jacek Konieczny <jajcus@pld.org.pl>
a4852742 562#
fbbdca08
JB
563%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
564%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
565%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
566%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
567%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
a1551c98 568
a4852742
JB
569#%_noautocompressdoc %{nil}
570#
5b0f0ac9
MM
571%_missing_doc_files_terminate_build 1%{nil}
572%_unpackaged_files_terminate_build %{nil}
4c7d3ba4 573# (X)emacs support
42b7e5ac 574%___emacs_lispdir_helper -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
a1551c98
ER
575%_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
576%_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
41a62699 577
984f6de6
JK
578%__php_provides %{nil}
579%__php_requires %{nil}
580%__perl_provides %{nil}
581%__perl_requires %{nil}
63b0a9d7 582%__mono_provides %{nil}
583%__mono_requires %{nil}
41a62699
AF
584
585# Perl specific macro definitions.
a1551c98
ER
586%perl_privlib %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
587%perl_archlib %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
588%perl_vendorlib %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
589%perl_vendorarch %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
590%perl_sitelib %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
591%perl_sitearch %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
41a62699 592
cb84f517 593# Ruby
a1551c98
ER
594%__ruby /usr/bin/ruby
595%ruby_archdir %{expand:%%global ruby_archdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)}%ruby_archdir
596%ruby_ridir %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
597%ruby_rubylibdir %{expand:%%global ruby_rubylibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_rubylibdir
598%ruby_vendorarchdir %{expand:%%global ruby_vendorarchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorarchdir
599%ruby_vendorlibdir %{expand:%%global ruby_vendorlibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorlibdir
600%ruby_sitearchdir %{expand:%%global ruby_sitearchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)}%ruby_sitearchdir
601%ruby_sitelibdir %{expand:%%global ruby_sitelibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)}%ruby_sitelibdir
602%ruby_version %{expand:%%global ruby_version %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)}%ruby_version
5483bb35
ER
603%ruby_ver_requires_eq Requires: ruby(ver) = %ruby_version
604%ruby_mod_ver_requires_eq Requires: ruby-modules(ver) = %ruby_version
cb84f517 605
3da52f86 606%php_pear_dir /usr/share/pear
a1551c98
ER
607%php_extensiondir %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
608%php_sysconfdir %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
609%php_includedir %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
41a62699 610
f73da51b 611# extract php/zend api versions
a1551c98
ER
612%php_major_version %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
613%php_api_version %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
614%php_pdo_api_version %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
615%php_debug %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
616%zend_module_api %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
617%zend_extension_api %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
618%zend_zts %{expand:%%global zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%zend_zts
6b2157a6
ER
619
620# helper macro
e255dfdc 621%__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
6b2157a6
ER
622
623# macros for public use
624# for php extensions (php-pecl)
ab8d73ee 625%requires_php_extension %{__php_api_requires modules_api php_api_version} \
cc2b296f 626%{__php_api_requires zend_module_api} \
e255dfdc
ER
627%{__php_api_requires -v %php_major_version debug php_debug} \
628%{__php_api_requires -v %php_major_version thread-safety zend_zts}
ab8d73ee 629
6b2157a6
ER
630# for zend extensions
631%requires_zend_extension %{__php_api_requires zend_module_api} \
ab8d73ee 632%{__php_api_requires zend_extension_api} \
e255dfdc
ER
633%{__php_api_requires -v %php_major_version debug php_debug} \
634%{__php_api_requires -v %php_major_version thread-safety zend_zts}
6b2157a6 635
1c107a2d
ER
636# for php pdo modules (php-pecl-PDO_*)
637%requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
638
e6ca24e8
ER
639# for using PHP post scripts. for PHP >= 5.0
640%php_webserver_restart \
641[ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
febce2c9 642[ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
b4080c85
ER
643if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
644 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
645 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
646 %service -q php-fcgi restart \
647 fi \
648fi \
e6ca24e8
ER
649%{nil}
650
651# for using php post scripts. for PHP >= 4.0 && PHP < 5.0
652%php4_webserver_restart \
653[ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
febce2c9 654[ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
b4080c85
ER
655if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
656 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
657 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
658 %service -q php-fcgi restart \
659 fi \
660fi \
e6ca24e8
ER
661%{nil}
662
b89f672e
AM
663
664# X.org helper macros
04336b74 665%__xorg_abi_requires() Requires: xorg-xserver-server(%{expand:%1}-abi) = %{expand:%{%{!?2:%{1}}%{?2}}}
b89f672e 666#
a1551c98
ER
667%xorg_xserver_ansic_abi %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
668%xorg_xserver_extension_abi %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
669%xorg_xserver_font_abi %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
670%xorg_xserver_videodrv_abi %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
671%xorg_xserver_xinput_abi %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
b89f672e
AM
672
673%requires_xorg_xserver_extension %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
674%{__xorg_abi_requires extension xorg_xserver_extension_abi}
675%requires_xorg_xserver_xinput %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
676%{__xorg_abi_requires xinput xorg_xserver_xinput_abi}
677%requires_xorg_xserver_font %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
678%{__xorg_abi_requires font xorg_xserver_font_abi}
679%requires_xorg_xserver_videodrv %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
680%{__xorg_abi_requires videodrv xorg_xserver_videodrv_abi}
681
41a62699
AF
682# Python specific macro definitions.
683# python main version
a1551c98 684%py_ver %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" || echo ERROR)}%py_ver
41a62699
AF
685
686# directories
a1551c98 687%py_prefix %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" || echo ERROR)}%py_prefix
31b569b6 688%py_libdir %{py_prefix}/%{_lib}/python%{py_ver}
a4f0b5e0 689%py_scriptdir %{py_prefix}/share/python%{py_ver}
31b569b6 690%py_incdir /usr/include/python%{py_ver}
3da52f86 691%py_sitedir %{py_libdir}/site-packages
a4f0b5e0 692%py_sitescriptdir %{py_scriptdir}/site-packages
31b569b6 693%py_dyndir %{py_libdir}/lib-dynload
41a62699
AF
694
695# pure python modules compilation
31b569b6 696%py_comp python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
41a62699 697
31b569b6 698%py_ocomp python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
41a62699
AF
699
700# Software written in Python language require Python with main version
5177c7b1 701%pyrequires_eq() Requires: %1
41a62699 702
ea4b2900
AF
703# Hardlink binary identical .pyc and .pyo files
704# (idea by glen <at> pld-linux <dot> org)
705%__spec_install_post_py_hardlink {\
f67bd19e 706%{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
ea4b2900 707[ ! -d "$RPM_BUILD_ROOT" ] || find "$RPM_BUILD_ROOT" -name '*.pyc' | while read a; do \
455bd3f1 708 b="${a%.pyc}.pyo"; \
ea4b2900
AF
709 if cmp -s "$a" "$b"; then \
710 ln -f "$a" "$b"; \
711 fi; \
712done \
f67bd19e 713}; __spec_install_post_py_hardlink } }
ea4b2900 714
16f6f416 715# remove python sources, so that check-files won't complain
ea4b2900
AF
716# (idea by glen <at> pld-linux <dot> org)
717%py_postclean() \
e4e8948b 718for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
9ba5542a 719 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
ea4b2900
AF
720done \
721%{nil}
722
67ed5b97 723# depmod macro
724%depmod() { \
fe30b3ea 725umask 022; \
67ed5b97 726if [ -e /boot/System.map-%1 ]; then \
31b569b6 727 /sbin/depmod -a -F /boot/System.map-%1 %1; \
67ed5b97 728else \
31b569b6
ER
729 if [ -e /boot/System.map ]; then \
730 /sbin/depmod -a -F /boot/System.map %1; \
731 else \
732 /sbin/depmod -a %1; \
733 fi \
67ed5b97 734fi; \
735}
736
495892af 737# XMMS specific macros
a1551c98
ER
738%xmms_prefix %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
739%xmms_exec_prefix %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
740%xmms_version %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
741%xmms_datadir %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
742%xmms_plugindir %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
743%xmms_visualization_plugindir %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
744%xmms_input_plugindir %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
745%xmms_output_plugindir %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
746%xmms_effect_plugindir %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
747%xmms_general_plugindir %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
748
749%_target_base_arch %{expand:%%global _target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')}%_target_base_arch
bb128216 750
e3618ee9 751# user/group checking macros
752#
753# Usage:
754# %userremove myuser
755#
756%userremove /usr/lib/rpm/user_group.sh user del
757%groupremove /usr/lib/rpm/user_group.sh group del
758#
759# Usage:
760# if %usertestrm myuser; then
761# /usr/sbin/userdel -r myuser
762# Note:
763# use these macros only if you need to call userdel/groupdel with
764# a non-standard option or take an extra action; otherwise use the
765# %userremove/%groupremove macros
766#
767%usertestrm /usr/lib/rpm/user_group.sh user testrm
768%grouptestrm /usr/lib/rpm/user_group.sh group testrm
13f70a2c
JK
769# user group membership management macros
770#
771# Usage:
772# %addusertogroup myuser agroup
773#
774%addusertogroup /usr/lib/rpm/user_group.sh user addtogroup
bfd9689c 775
776# banner support (useful in {pre,post}{,un} and triggers)
777#
778# Usage:
a980efc1 779# %banner name [-a] [-e] [-n] [-tn] <<EOF
bfd9689c 780# the banner text, the banner text
a980efc1
ER
781# the banner text, and following line
782#EOF
783# You can use any form of here-document, <<'EOF' <<-EOT will do.
784# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
785#
bfd9689c 786# -a - append to the banner
fb033326 787# -e - send to stderr instead of stdout
1257c400 788# -n - no show banner (overrides -t)
789# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
4055114a
ER
790#
791# Tests:
792# (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
793# rpm -E 'date | %banner -e banner' > m; sh -x m
794#
8bea2501 795%banner(aent:) ( \
f1bbc6ff 796RPM_SCRIPTVERBOSITY=5 \
797[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
798if [ -x /usr/bin/banner.sh ]; then \
a980efc1 799 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
f1bbc6ff 800else \
fb033326 801 CMD="cat%{-e: >&2}" \
f1bbc6ff 802fi \
4055114a
ER
803eval $CMD %{?2:%2}%{?3: %3}) \
804%{nil}
1257c400 805
3c972982 806# useradd/groupadd macros
1ebc460a 807# Author: Elan Ruusamäe <glen@pld-linux.org>
29c5556c
ER
808#
809# Usage:
810# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
811# [-g initial_group] [-G group[,...]] login
812#
813# -u uid. REQUIRED
814# -g gid/group. REQUIRED
815# -s defaults to /bin/false
816# -d defaults to /usr/share/empty
817# -c No default
818# -r is accepted but ignored (it's always set)
6eb25d5d 819# -k skeleton dir. defaults to /usr/share/empty
29c5556c
ER
820# rpm specific flags
821# -P package name. defaults to %{name}
822#
29c5556c 823%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
0044d46f
ER
824%{!-u:%{error:useradd: Required argument -u missing}} \
825%{!-g:%{error:useradd: Required argument -g missing}} \
826%{!?1:%{error:useradd: Required parameter login missing}} \
29c5556c
ER
827if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
828 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
829 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
830 exit 1 \
831 fi \
832else \
833 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
834 /usr/sbin/useradd \\\
cc333c8b 835 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
29c5556c
ER
836 -u %{-u*} \\\
837 -r \\\
838 -d %{-d*}%{!-d:/usr/share/empty} \\\
839 -s %{-s*}%{!-s:/bin/false} \\\
85e3e9a1 840 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
29c5556c
ER
841 -g %{-g*} \\\
842 %{-M} \\\
843 %{-G:-G %{-G*}} \\\
6750d9f5 844 %{expand:%{%{#}}} 1>&2 || exit $? \
52e30914 845 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
29c5556c
ER
846fi;
847
29c5556c
ER
848# Usage:
849# %groupadd [-P package] [-g gid] group
850#
851# -g gid. REQUIRED
852#
853# Sample:
854# %groupadd -P %{name}-base -g %{gid} %{name}
855
856%groupadd(g:P:rfo) \
0044d46f
ER
857%{!-g:%{error:groupadd: Required argument -g missing}} \
858%{!?1:%{error:groupadd: Required parameter group missing}} \
29c5556c
ER
859if [ -n "`/usr/bin/getgid %{1}`" ]; then \
860 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
861 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
862 exit 1 \
863 fi \
864else \
865 echo "Adding group %{1} GID=%{-g*}." \
6750d9f5 866 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
52e30914 867 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
29c5556c 868fi;
053b8de1 869
55a50f1a 870# webapp macros
1ebc460a 871# Author: Elan Ruusamäe <glen@pld-linux.org>
ba42a822
ER
872#
873# The config is installed/removed inside trigger, this means that you can any
874# time install apache1/apache/lighttpd package and the configuration file is
43f81f06 875# updated. if you don't need the config for various reason for specific
ba42a822
ER
876# webserver, just remove the symlink from config directory using webapp
877# program. the trigger will not recreate the symlink on upgrades. In other
878# words the config is linked to webserver config directory on first install of
879# PACKAGE or WEBSERVER.
880#
55a50f1a
ER
881# Add package's webserver config to webserver webapps dir.
882# Usage:
217f2cb2 883# %webapp_register WEBSERVER WEBAPP
ba42a822
ER
884#
885%webapp_register() \
886%{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
887if [ "$1" = "1" ] && [ "$2" = "1" ]; then\
888 /usr/sbin/webapp register %1 %2\
889fi\
973c1dc7 890# reload webserver if the config symlink is there and skip reload if webserver is upgraded\
afe4f5f0 891if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
5f0b2e29 892 %{expand:%service -q %%1 reload}\
ba42a822
ER
893fi\
894%{nil}
895
896# Remove package's config from webserver webapps dir.
ba42a822 897# Usage:
b9588fe6
ER
898# %webapp_register [-f] WEBSERVER WEBAPP
899%webapp_unregister(f) \
ba42a822
ER
900%{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
901# remove link if either of the packages are gone \
afe4f5f0 902if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
217f2cb2 903 /usr/sbin/webapp unregister %1 %2\
5f0b2e29 904 %{expand:%service -q %%1 reload}\
ba42a822
ER
905fi \
906%{nil}
907
8edf8498 908# service macro.
1ebc460a 909# Author: Elan Ruusamäe <glen@pld-linux.org>
8edf8498
ER
910#
911# calls usual service restart on package %post, but skips the restart if
912# administrator has disabled automatic service restarts in either global
913# /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
914#
8edf8498 915# Usage:
524e081b 916# %service [-q] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
8edf8498 917#
dd4e969a 918# -q be silent when service isn't started (for scriplets restaring other package's services)
8edf8498 919#
e42cbd35 920%service(q) {{%(export quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
cec3a041
ER
921
922
91bd3172
ER
923# Java macros. based on jpackage macros.java
924#
925# Root directory where all Java VMs/SDK/JREs are installed.
93406dd9 926%_jvmdir %{_libdir}/jvm
91bd3172
ER
927
928# Root directory where all Java VMs/SDK/JREs expose their jars
93406dd9 929%_jvmjardir %{_libdir}/jvm-exports
91bd3172
ER
930
931# Root directory for all Java VM/SDK/JRE's private things.
932%_jvmprivdir %{_libdir}/jvm-private
933
934# Root directory for all architecture dependent parts of Java VM/SDK/JRE's
93406dd9 935%_jvmlibdir %{_libdir}/jvm
91bd3172
ER
936
937# Root directory for all architecture independent parts of Java VM/SDK/JRE's
938%_jvmdatadir %{_datadir}/jvm
939
940# Root directory for all configurations parts of Java VM/SDK/JRE's
941%_jvmsysconfdir %{_sysconfdir}/jvm
942
943# Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
29959405 944%_jvmcommonlibdir %{_libdir}/jvm-common
91bd3172
ER
945
946# Root directory for all common architecture independent parts of Java VM/SDK/JRE's
29959405 947%_jvmcommondatadir %{_datadir}/jvm-common
91bd3172
ER
948
949# Root directory for all common configurations parts of Java VM/SDK/JRE's
29959405 950%_jvmcommonsysconfdir %{_sysconfdir}/jvm-common
91bd3172
ER
951
952# Directory where arch-specific (JNI) version-independent jars are installed.
93406dd9 953%_jnidir %{_libdir}/java
91bd3172 954
a1551c98 955%java_home %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo ${JAVA_HOME:-ERROR})}%java_home
cec3a041 956
43f81f06
ER
957%ant JAVA_HOME=%{java_home} ant
958%jar %{java_home}/bin/jar
a1551c98 959%java %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)}%java
43f81f06
ER
960%javac %{java_home}/bin/javac
961%javadoc %{java_home}/bin/javadoc
cec3a041 962
43f81f06 963%add_jvm_extension JAVA_LIBDIR=%{buildroot}/%{_javadir} %{_bindir}/jvmjar -l
cec3a041
ER
964
965%jpackage_script() \
a2047fce
ER
966install -d $RPM_BUILD_ROOT%{_bindir}\
967cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
cec3a041
ER
968#!/bin/sh\
969#\
970# %{name} script\
971# JPackage Project <http://www.jpackage.org/>\
972\
973# Source functions library\
974. %{_javadir}-utils/java-functions\
975\
976# Source system prefs\
a2047fce 977if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
43f81f06 978 . %{_sysconfdir}/java/%{name}.conf\
cec3a041
ER
979fi\
980\
981# Source user prefs\
a2047fce
ER
982if [ -f $HOME/.%{name}rc ]; then\
983 . $HOME/.%{name}rc\
cec3a041
ER
984fi\
985\
986# Configuration\
987MAIN_CLASS=%1\
988BASE_FLAGS=%2\
989BASE_OPTIONS=%3\
a2047fce 990BASE_JARS="%(echo %4 | tr ':' ' ')"\
cec3a041
ER
991\
992# Set parameters\
993set_jvm\
a2047fce
ER
994set_classpath $BASE_JARS\
995set_flags $BASE_FLAGS\
996set_options $BASE_OPTIONS\
cec3a041
ER
997\
998# Let's start\
a2047fce 999run "$@"\
cec3a041
ER
1000EOF
1001
d449d2c8
ER
1002# jpackage 1.7
1003# Directory for maven depmaps
1004#
1005%_mavendepmapdir /etc/maven
1006%_mavendepmapfragdir /etc/maven/fragments
1007
1008#
1009# add_to_depmap adds an entry to the depmap. The arguments are:
1010#
1011# %1 the original groupid
1012# %2 the original artifact id
1013# %3 the version
1014# %4 the new groupid
1015# %5 the new artifactid
1016#
1017
1018%add_to_maven_depmap() \
1019install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1020cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1021<dependency>\
1022 <maven>\
1023 <groupId>%1</groupId>\
1024 <artifactId>%2</artifactId>\
1025 <version>%3</version>\
1026 </maven>\
1027 <jpp>\
1028 <groupId>%4</groupId>\
1029 <artifactId>%5</artifactId>\
1030 <version>%3</version>\
1031 </jpp>\
1032</dependency>\
1033\
1034EOF\
1035%{nil}
1036
1037#==============================================================================
1038#
1039# update_maven_depmap updates the main maven depmap
1040#
1041%update_maven_depmap() \
1042echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1043if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1044cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1045fi\
1046echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1047
1048
e22fc3d1 1049# PEAR install macros
1ebc460a 1050# Author: Elan Ruusamäe <glen@pld-linux.org>
d2a29d34
ER
1051#
1052# Usage:
1053# %%pear_package_setup [-a #] [-n FMT]
1054#
e22fc3d1 1055# -a # - also unpack SOURCE#. for PEAR bootstrapping
d2a29d34 1056# -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
e22fc3d1 1057# -z - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
d2a29d34
ER
1058#
1059# unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1060# destination hierarchy. you should copy the tree to buildroot after
1061# patching/reorganizing with %%pear_package_install.
1062#
1063# additionally BUILDROOT is stripped from files and files are converted to UNIX
1064# line endings.
1065#
1066# the pear install process output is recorded to install.log, you should put it
a4f06f46 1067# to %%doc for later debug or just for information.
d2a29d34
ER
1068#
1069# additionally additional-packages.txt is produced if it was detected that the
1070# package has optional dependencies. the file format is suitable of displaying
1071# in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1072# automatically added for this file.
e22fc3d1
ER
1073
1074
1075# records install.log and transforms PEAR names to PLD Linux rpm package names.
1076%__pear_install_log \
1077tee install.log \
1078# make post message of optional packages \
1079grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,' > optional-packages.txt \
1080if [ -s optional-packages.txt ]; then \
1081 awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1082else \
1083 rm -f optional-packages.txt \
1084fi \
1085%{nil}
1086
1087# command invoking pear cli
1088%__pear /usr/bin/pear
1089
856feeea 1090%pear_install(a:n:zD) \
e22fc3d1
ER
1091%__pear \\\
1092 -c pearrc \\\
d2a29d34
ER
1093 -d doc_dir=/docs \\\
1094 -d php_dir=%{php_pear_dir} \\\
1095 -d bin_dir=%{_bindir} \\\
1096 -d data_dir=%{php_pear_dir}/data \\\
1097 -d test_dir=%{php_pear_dir}/tests \\\
1098 install \\\
e22fc3d1 1099 --packagingroot=%{builddir} \\\
d2a29d34
ER
1100 --offline \\\
1101 --nodeps \\\
1102 %{-f:--force} \\\
856feeea
ER
1103 %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
1104%{nil}
1105
1106# The main macro.
1107# using this macro will append optional-packages.txt to the nocompressdoc list
1108# as it's displayed to user after package install. and adding additional gzip
1109# dep is just waste ;)
1110%pear_package_setup(a:n:zD) \
1111%define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1112%define builddir %{_builddir}/%{srcdir} \
1113%setup -q -c -T %{-D:-D} -n %{srcdir} \
1114%{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1115%{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1116%pear_install \
e22fc3d1
ER
1117%{-z:cd ..} \
1118cat %{-z:$_N/}.install.log | %__pear_install_log \
1119\
d2a29d34 1120# undos sources \
07fa2259 1121find -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
d2a29d34
ER
1122%{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1123%{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1124%{nil}
1125
0aced28c 1126# Copies exctracted PEAR package structure and PEAR registry to buildroot.
1ebc460a 1127# Author: Elan Ruusamäe <glen@pld-linux.org>
d2a29d34
ER
1128%pear_package_install() \
1129cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1130find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1131# help the developer out a little: \
1132if [ -f _noautoreq ]; then \
1133 echo "AutoReqdep detected:" \
1134 echo "_noautoreq $(cat _noautoreq)" \
1135fi \
1136%{nil}
1137
54294c49
ER
1138
1139# Register OpenLDAP schema.
1ebc460a 1140# Author: Elan Ruusamäe <glen@pld-linux.org>
54294c49
ER
1141#
1142# Usage:
1143# %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1144#
1145# -d specify dependant schemas, separated by comma
1146#
1147%openldap_schema_register(d:) \
1148for schema in %*; do \
1149 if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1150 %{__sed} -i -e " \
1151 /^include.*local.schema/{ \
1152 iinclude\\t $schema\
1153 } \
1154 " /etc/openldap/slapd.conf \
1155 fi \
1156done \
1157# enable dependant schemas \
1158if [ "%{-d*}" ]; then \
1159 %{__sed} -i -e ' \
1160 /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1161 s/^#// \
1162 }' /etc/openldap/slapd.conf \
1163fi \
1164%{nil}
1165
1166# Unregister OpenLDAP schema.
1ebc460a 1167# Author: Elan Ruusamäe <glen@pld-linux.org>
54294c49
ER
1168#
1169# Usage:
1170# %%openldap_schema_unregister %{schemadir}/horde.schema
1171#
1172%openldap_schema_unregister() \
1173for schema in %*; do \
1174 if grep -q "$schema" /etc/openldap/slapd.conf; then \
1175 %{__sed} -i -e " \
1176 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1177 # for symmetry it would be nice if we disable enabled schemas in post, \
1178 # but we really can not do that, it would break something else. \
1179 " /etc/openldap/slapd.conf \
1180 fi \
1181done \
1182%{nil}
1183
feb61fae 1184%env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
6ee06092 1185
a4623211 1186
1187# Build modules for kernels 2.6
1188# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1189#
1190# Usage:
650cc681 1191# %build_kernel_modules -m <modules> -C <directory>
a4623211 1192#
1193# remember that proper Makefile is still required
1194# Options:
3c972982 1195# -m <modules> (required) -- comma-separated list of modules to save,
a4623211 1196# without .ko extension, may be placed in subdirectory
650cc681 1197# -C <directory> -- change to <directory> before doing anything
a4623211 1198# -p <arg>, -P <arg> -- arguments passeed to make scripts
bf97e3a6 1199# -c -- do not execute make clean
a4623211 1200# <additional arguments> -- all additional arguments will be passed to
1201# make modules
1202#
1203# Additional patching supported via here document. Try:
1204# %build_kernel_modules -m module <<'EOF'
1205# your patch script here
1206# EOF
1207# Don't use it unless patching depends on config options.
1208
1209# Developer note: don't touch it unless you know how to handle '\'.
1210# - \ in script expands to nothing
1211# - \\\ in script expands to \
8ad8b353 1212# - \\\ inside definition expands to nothing
a4623211 1213# - \\\\\\\ inside definition expands to \
1214# - in last line \ has to touch arguments so arguments passing
1215# in new lines (using \) will be supported
1216
bf97e3a6 1217%build_kernel_modules(p:P:m:C:c) \
a4623211 1218%{!?-m:%{error:%{0}: Required module name/list missing} exit 1} \
1219 \
1220%define Opts \\\\\\\
1221%if "%{_target_base_arch}" != "%{_arch}" \\\
1222 %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386" \\\
4d45063a 1223 CC="%{kgcc}" ARCH=%{_target_base_arch} \\\
a4623211 1224 %else \\\
1225 ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1226 %endif \\\
1227%else \\\
4d45063a 1228 CC="%{kgcc}" \\\
a4623211 1229%endif \
4d45063a 1230%define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
a4623211 1231 O=$PWD/o %{?with_verbose:V=1} %{Opts} \
1232 \
8b51c37f 1233%{?-C:cd %{-C*}} \
a4623211 1234compile() { \
1235 L="<"; [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)" \
1236 set -e -x \
d606f9ca 1237 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
a4623211 1238 \
d606f9ca 1239for cfg in ${cfgs:-dist}; do \
a4623211 1240 [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1 \
1241 \
8e042a98 1242 rm -rf o \
a4623211 1243 install -d o/include/linux \
1244 ln -sf %{_kernelsrcdir}/config-$cfg o/.config \
1245 ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers \
1246 ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1247 \
1248 set +x \
1249 [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell \
1250 set -x \
1251 \
1252 %if %{with dist_kernel} \
1253 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts \\\
1254 %{-p*} %{-P*} \\\
1255 %{MakeOpts} \
1256 %else \
1257 install -d o/include/config \
1258 touch o/include/config/MARKER \
1259 ln -sf %{_kernelsrcdir}/scripts o/scripts \
1260 %endif \
1261 \
bf97e3a6 1262 %{!?-c:%{__make} -C %{_kernelsrcdir} clean \\\
a4623211 1263 RCS_FIND_IGNORE="-name '*.ko' -o" \\\
220948bb 1264 ${1+"$@"} \\\
bf97e3a6 1265 M=$PWD %{MakeOpts}} \
220948bb 1266 \
a4623211 1267 %{__make} -C %{_kernelsrcdir} modules \\\
1268 ${1+"$@"} \\\
1269 M=$PWD %{MakeOpts} \
1270 \
1271 for MODULE in {%{-m*},}; do \
1272 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko \
1273 done \
1274done \
650cc681 1275%{?-C:cd -} \
a4623211 1276} \
1277compile %{*}\
1278%{nil}
1279
1280
1281# Install kernel modules built by %build_kernel_modules
1282# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1283#
1284# Usage:
1285# %install_kernel_modules -m <modules> -d <directory>
1286#
1287# Options:
3c972982 1288# -m <modules> (required) -- comma-separated list of modules to install,
a4623211 1289# without .ko extension, may be placed in subdirectory
1290# -d <directory> (required) -- in what subdirectory modules should be
1291# installed (eg. misc, kernel/drivers/net)
1292# -s <suffix> -- suffix to use when installing modules, useful when module
1293# with same name exists in kernel already
1294# -n <file> -- name of modprobe config file to use (without .conf extension)
c4bd6177 1295# for defining aliases, only useful with -s
a4623211 1296
1297%install_kernel_modules(m:d:s:n:) \
1298%{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1} \
1299%{!?-d:%{error:%{0}: Required module directory missing}exit 1} \
1300%{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1301 \
1302%define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver} \
1303%define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
c6bb8dfe 1304 \
d606f9ca 1305local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
a4623211 1306 \
1307for MODULE in {%{-m*},}; do \
1308 [ -n "${MODULE}" ] || continue \
d606f9ca
ER
1309 for cfg in ${cfgs:-dist}; do \
1310 [ "$cfg" = smp ] && suf=smp || suf= \
1311 MNAME=${MODULE##*/} \
1312 install -D ${MODULE}-$cfg.ko \\\
1313 %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko \
b37738c0 1314 %{?-s:install -d %{ModprobeD}$suf \
d606f9ca
ER
1315 echo "alias ${MNAME} ${MNAME}-%{-s*}" \\\
1316 >> %{ModprobeD}$suf/%{-n*}.conf} \
1317 done \
a4623211 1318done \
1319%{nil}
1320
16516cbd 1321# patchset macros
1ebc460a 1322# Author: Elan Ruusamäe <glen@pld-linux.org>
16516cbd
ER
1323#
1324# Usage:
1325# %patchset_source -f <seq(1) format> <start> [<end>]
1326# %patchset_patch <start> [<end>]
1327#
1328# If <end> is omited, it is assumed to be <start>.
1329#
1330# For example in preamble:
1331# %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1332# and in %prep:
1333# %patchset_patch 33 44
1334
1335# generate SourceX urls from range START STOP
1336# Format can be SINGLE format char of %e, %f, %g, see seq(1)
1337# The sources start from 10000
cc2d394a 1338%patchset_source(f:b:) %(
8c40a202 1339 base=%{-b*}%{!-b*:10000};
3b7f1777
ER
1340 start=$(expr $base + %1);
1341 end=$(expr $base + %{?2}%{!?2:%{1}});
cc2d394a
ER
1342 # we need to call seq twice as it doesn't allow two formats
1343 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1344 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1345 paste %{tmpdir}/__ps{1,2};
1346 rm -f %{tmpdir}/__ps{1,2};
3b7f1777
ER
1347) \
1348%{nil}
16516cbd
ER
1349
1350# apply sources from %patchset_source
1351# -p specify -pX for %patch line
1352# -b base offset: defaults to 10000
1353%patchset_patch(f:p:b:) %(
8c40a202 1354 base=%{-b*}%{!-b*:10000};
3b7f1777
ER
1355 start=$(expr $base + %1);
1356 end=$(expr $base + %{?2}%{!?2:%{1}});
cc2d394a
ER
1357 echo ": patchset_patch %1%{?2: to %2}";
1358 seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
3b7f1777
ER
1359) \
1360%{nil}
16516cbd 1361
c7cb683a 1362# browser plugins v2
1ebc460a 1363# Author: Elan Ruusamäe <glen@pld-linux.org>
c7cb683a
ER
1364#
1365# Usage:
1366# %browser_plugins_add_browser <name> -p <plugindir>
1367#
1368# <name> (required) -- name of the browser. usually %{name}.
1369# -p <plugindir> (required) -- in what directory browser searches for its plugins.
825d0960
ER
1370# -b -- default blacklists
1371# -a <arch> override arch
c7cb683a
ER
1372#
1373# Example:
1374# %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1375
1376%_browserpluginsconfdir /etc/browser-plugins
292d3658 1377%_browserpluginsdir %{_libdir}/browser-plugins
c7cb683a
ER
1378%update_browser_plugins /usr/sbin/update-browser-plugins || :
1379
825d0960 1380%browser_plugins_add_browser(p:b:a:) \
2ac4652b 1381 browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
c7cb683a 1382 install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
825d0960
ER
1383 ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1384 blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
c7cb683a
ER
1385 echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1386 %{-b:cat >> $blacklist_file %{-b*}} \
1387%{nil}
1388
c879189d
ER
1389# Helper for LUA.
1390# split string separated by space into quoted list
1391#
1ebc460a 1392# Author: Elan Ruusamäe <glen@pld-linux.org>
c879189d
ER
1393#
1394# %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1395%__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1396
1397# adjust /etc/shells by adding and removing shells from there
1ebc460a 1398# Author: Elan Ruusamäe <glen@pld-linux.org>
c879189d
ER
1399#
1400# Usage:
1401# %post -p %add_etc_shells -p /bin/sh /bin/pdksh
1402# %preun -p %remove_etc_shells -p /bin/sh /bin/pdksh
1403#
1404# -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1405
1406%add_etc_shells(p) %{-p:<lua>}\
1407t = {}\
1408f = io.open("/etc/shells", "r")\
1409if f then\
1410 for l in f:lines() do t[l]=l; end\
1411 f:close()\
1412end\
1413for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1414 if not t[s] then\
b566b93e 1415 print("Adding "..s.." to /etc/shells")\
c879189d
ER
1416 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1417 end\
1418end\
1419%{nil}
1420
1421%remove_etc_shells(p) %{-p:<lua>}\
b566b93e 1422%{-p:if arg[2] == 0 then}\
39e5924d
ER
1423 t = {}\
1424 f = io.open("/etc/shells", "r")\
1425 if f then\
1426 for l in f:lines() do t[l]=l; end\
1427 f:close()\
1428 end\
1429 for _, l in pairs({%{expand:%%__lua_split %*}}) do\
b566b93e 1430 print("Removing "..l.." from /etc/shells")\
39e5924d
ER
1431 t[l] = nil\
1432 end\
1433 s=""\
1434 for _, l in pairs(t) do\
1435 s=s..l.."\\n"\
1436 end\
1437 io.open("/etc/shells", "w"):write(s)\
1438%{-p:end} \
c879189d
ER
1439%{nil}
1440
e22fc3d1 1441# vim:ts=4 sw=4 noet syn=spec
This page took 0.47642 seconds and 4 git commands to generate.